/*---------------------------------------------------------------------------------------------------------------------------------
---
--- Progam Name		: 	FLKMFG PR/IR TO PO/ISO  CANCELLATION
--- Program File Name	:	FLKMFG_PRIR_TO_POISO_CANCEL_B.sql
--- Program Type        : 	Package Body
--- Parameters		: 	N/A
--- DEV Instance		:	DEV9
--- Description         : 	This Package Cancells the POS ,ISO Lines  for the IR and PR Lines  which are cancelled 
---				
----				
----				
				
----				
----				
-----				
-----				
--- Created By                 Prashant Kale 
--- Creation Date             21-Aug-2007
--- Modification History:      Date	 	Modified By		Comments
---					----		-----------		--------
---					Prashant Kale    
---------------------------------------------------------------------------------------------------------------------------------*/


CREATE OR REPLACE PACKAGE BODY  flk_prir_to_poiso_cancel 
IS  
		  l_userid                     NUMBER  :=fnd_profile.value('USER_ID'); 
		  l_conc_request_id            NUMBER  :=fnd_profile.value('CONC_REQUEST_ID');
		  x_header_rec                 Oe_Order_Pub.Header_Rec_Type;
		  x_header_val_rec             Oe_Order_Pub.Header_Val_Rec_Type;
		  x_Header_Adj_tbl             Oe_Order_Pub.Header_Adj_Tbl_Type;
		  x_Header_Adj_val_tbl         Oe_Order_Pub.Header_Adj_Val_Tbl_Type;
		  x_Header_price_Att_tbl       Oe_Order_Pub.Header_Price_Att_Tbl_Type;
		  x_Header_Adj_Att_tbl         Oe_Order_Pub.Header_Adj_Att_Tbl_Type;
		  x_Header_Adj_Assoc_tbl       Oe_Order_Pub.Header_Adj_Assoc_Tbl_Type;
		  x_Header_Scredit_tbl         Oe_Order_Pub.Header_Scredit_Tbl_Type;
		  x_Header_Scredit_val_tbl     Oe_Order_Pub.Header_Scredit_Val_Tbl_Type;
		  x_line_tbl                   Oe_Order_Pub.Line_Tbl_Type;
		  x_line_val_tbl               Oe_Order_Pub.Line_Val_Tbl_Type;
		  x_Line_Adj_tbl               Oe_Order_Pub.Line_Adj_Tbl_Type;
		  x_Line_Adj_val_tbl           Oe_Order_Pub.Line_Adj_Val_Tbl_Type;
		  x_Line_price_Att_tbl         Oe_Order_Pub.Line_Price_Att_Tbl_Type;
		  x_Line_Adj_Att_tbl           Oe_Order_Pub.Line_Adj_Att_Tbl_Type;
		  x_Line_Adj_Assoc_tbl         Oe_Order_Pub.Line_Adj_Assoc_Tbl_Type;
		  x_Line_Scredit_tbl           Oe_Order_Pub.Line_Scredit_Tbl_Type;
		  x_Line_Scredit_val_tbl       Oe_Order_Pub.Line_Scredit_Val_Tbl_Type;
		  x_Lot_Serial_tbl             Oe_Order_Pub.Lot_Serial_Tbl_Type;
		  x_Lot_Serial_val_tbl         Oe_Order_Pub.Lot_Serial_Val_Tbl_Type;
		  x_action_request_tbl         Oe_Order_Pub.Request_Tbl_Type;
		  l_line_tbl                   Oe_Order_Pub.Line_Tbl_Type;
		  l_tmp_line_tbl               Oe_Order_Pub.Line_Tbl_Type;
		  p_line_tbl                   Oe_Order_Pub.Line_Tbl_Type;
		  l_header_rec                 Oe_Order_Pub.Header_Rec_Type;
		  x_return_status              VARCHAR2(10);
		  x_msg_count                  NUMBER;
		  x_msg_data                   VARCHAR2(100);
		  m                            NUMBER := 0;
		  l_count                      NUMBER;
		  l_set_name                   VARCHAR2(30);
		  l_nHeaderId                  NUMBER;        
		  l_message 		       VARCHAR2(2000);
		  l_msg_index_out              NUMBER;
		  l_ln_cnt                     NUMBER;
		  l_conc_req_id		       NUMBER;

PROCEDURE  prir_to_poiso_cancellation 
	IS 


		             
-----This cursor will fetch the data for the po lines which are to be cancelled 		             

CURSOR C2  IS 
 SELECT DISTINCT porla.requisition_line_id
        ,porha.requisition_header_id
        ,porha.segment1 requisition_number 
        ,porla.line_num 
        ,poha.segment1 po_number
        ,poha.po_header_id
        ,pola.po_line_id
        ,polla.line_location_id
        ,pola.line_num po_line_num
  FROM   po_requisition_lines_all porla
     	  ,po_requisition_headers_all porha
     	  ,po_req_distributions_all porda
     	  ,po_headers_all poha
     	  ,po_lines_all pola
     	  ,po_line_locations_all polla
     	  ,po_distributions_all poda		
 WHERE   1=1
   AND   porha.requisition_header_id = porla.requisition_header_id
   AND   porda.requisition_line_id  = porla.requisition_line_id 
   AND   poda.req_distribution_id      = porda.distribution_id
   AND   poda.line_location_id = polla.line_location_id
   AND   NVL(polla.quantity_received,0) = 0
   AND   NVL(polla.attribute7,'B2B') NOT LIKE 'SHIP%'
   AND   poha.po_header_id  = pola.po_header_id
   AND   pola.po_line_id = polla.po_line_id
   AND   PORLA.cancel_flag ='Y'
   AND   NVL(POLLA.cancel_flag,'N') != 'Y'
   AND   poha.org_id IN (SELECT organization_id
                            FROM hr_operating_units		
                                   WHERE organization_id IN 
                           (SELECT organization_id 
                          FROM hr_all_organization_units 
                             WHERE attribute17 = 'Yes')); ---PO Line Location Line which is not cancelled 
																										
CURSOR C3 IS 																						
   SELECT DISTINCT porla.requisition_line_id,
          porha.requisition_header_id,
	    porla.line_num, 
          porha.segment1 requisition_number,
          oeh.header_id header_id2,
          oeh.order_number order_number2,
	    oeh.org_id,
          oel.line_id    line_id2,
	    oel.line_number order_line_num,
          oel.ordered_quantity,
          oel.flow_status_code,
          oel.line_number
    FROM  po_requisition_lines_all porla,
          po_requisition_headers_all porha,
          po_req_distributions_all porda,
          oe_order_lines_all oel,
          oe_order_headers_all oeh		
  WHERE   1=1
    AND   porha.segment1 = oeh.orig_sys_document_ref
    AND   porha.requisition_header_id = porla.requisition_header_id
    AND   porda.requisition_line_id  = porla.requisition_line_id 
    AND   porla.cancel_flag ='Y'
    AND   porla.requisition_header_id = oeh.source_document_id
    AND   porla.requisition_line_id  = oel.source_document_line_id
    AND   oeh.header_id =oel.header_id
    AND   porla.requisition_header_id = oeh.source_document_id
    AND   porla.requisition_line_id  = oel.source_document_line_id
    AND   oel.orig_sys_line_ref = TO_CHAR(porla.line_num)
    AND   oel.order_source_id = 10
    AND   oel.open_flag = 'Y'
    AND   oel.flow_status_code NOT IN ('CLOSED','CANCELLED','SHIPPED','FULFILLED','INVOICED')
-- AND    TO_CHAR(porla.line_num)    = oel.orig_sys_line_ref
 --AND    porha.segment1 LIKE '610033217-FCO-0'
   AND    porHa.org_id IN (SELECT organization_id
                           FROM hr_operating_units		
                          WHERE organization_id IN (SELECT organization_id 
				                      FROM hr_all_organization_units 
       	                      WHERE attribute17 = 'Yes'))
   UNION 
 SELECT   DISTINCT 
	    porla.requisition_line_id,
          porha.requisition_header_id,
	    porla.line_num, 
          porha.segment1 requisition_number,
          oeh.header_id header_id2,
          oeh.order_number order_number2,
          oeh.org_id,
          oel.line_id    line_id2,
	    oel.line_number order_line_num,
          oel.ordered_quantity,
          oel.flow_status_code,
          oel.line_number
 FROM    po_requisition_lines_all porla,
         po_requisition_headers_all porha,
         oe_order_lines_all oel,
         oe_order_headers_all oeh		
WHERE   1=1
  AND   porha.requisition_header_id = porla.requisition_header_id
  AND   PORHA.ORG_ID=PORLA.ORG_ID
		AND   porHa.org_id IN (SELECT organization_id
                           FROM hr_operating_units		
                          WHERE organization_id IN (SELECT organization_id 
				                      FROM hr_all_organization_units 
				                      WHERE attribute17 = 'Yes'))
  AND   porla.cancel_flag ='Y'
  AND   oel.line_id=TO_NUMBER(porla.attribute4)
  AND   oeh.header_id =oel.header_id
  AND   oeh.open_flag = 'Y'
  AND   oel.open_flag = 'Y'
  AND   oeh.ordered_date BETWEEN SYSDATE-100000 AND SYSDATE+100000
  AND  OEH.ORG_ID=OEL.ORG_ID
  AND   oel.flow_status_code NOT IN ('CLOSED','CANCELLED','SHIPPED','FULFILLED','INVOICED');													

BEGIN 

	 Fnd_file.put_line(fnd_file.output,'Starting the PR/IR To PO/ISO Canellation statement'); 
 	 Fnd_file.put_line(fnd_file.output,'**1--Starting the PR  To PO  Canellation ');  
     
 FOR j IN c2  LOOP
       
         Fnd_file.put_line(fnd_file.output,'*****************************************************************************************************************************************************************************');
         Fnd_file.put_line(fnd_file.output,'                                                                                                                                                    ');
         Fnd_file.put_line(fnd_file.output,'-----Processing Req # --'||j.requisition_number||'--Req Ln #'||j.line_num||'--Req Id---- '||j.requisition_header_id||'--Req Ln Id'||j.requisition_line_id);
	   Fnd_file.put_line(fnd_file.output,'----Cancelling PO  # --'||j.po_number||'--PO Ln # ---'||j.po_line_num||'---PO Id  -- '||j.po_header_id||'--PO Ln Id ----- '||j.po_line_id);
        -- Fnd_file.put_line(fnd_file.output,'--Cancelling The PO Line   Id ----- '||j.po_line_id);
        
  
      UPDATE PO_DISTRIBUTIONS_all POD 
	   SET pod.quantity_cancelled = pod.quantity_ordered - DECODE(SIGN(NVL(quantity_delivered,0) - 
		 NVL(quantity_billed,0)),1, NVL(quantity_delivered,0),NVL(quantity_billed,0)),
      	 pod.last_update_date =SYSDATE,
      	 pod.last_updated_by = l_userid,
      	 pod.gl_cancelled_date = SYSDATE
	 WHERE pod.line_location_id IN ( SELECT poll.line_location_id
							   FROM   po_line_locations_all poll
							   WHERE  poll.po_line_id = j.po_line_id
        							     AND    NVL(poll.cancel_flag, 'N') = 'N'
       							     AND NVL(poll.closed_code, 'OPEN') != 'FINALLY CLOSED');             
         

      UPDATE PO_LINE_LOCATIONS_all POLL
	   SET POLL.cancel_flag = 'Y',
		 POLL.cancel_date = SYSDATE,
		 POLL.cancel_reason = 'Cancel Testing',
		 POLL.cancelled_by =  l_userid,
		 POLL.last_update_date = SYSDATE,
		 POLL.last_updated_by = l_userid,
		 POLL.quantity_cancelled =  (SELECT SUM(NVL(POD.quantity_cancelled,0))
							FROM   PO_DISTRIBUTIONS_all POD	
	 								WHERE  POD.line_location_id = POLL.line_location_id)
	WHERE POLL.po_line_id = j.po_line_id
	AND   NVL(poll.cancel_flag,'N') = 'N'
	AND   NVL(poll.closed_code, 'OPEN') != 'FINALLY CLOSED';            

     UPDATE po_lines_all pol
	SET   pol.cancel_flag = 'Y',
		pol.cancel_date = SYSDATE,
		pol.cancel_reason = 'SO Line is Canceled',
		pol.cancelled_by = l_userid,
		pol.last_update_date = SYSDATE,
		pol.last_updated_by = l_userid,
		--pol.last_update_login = :login_id,
		pol.quantity = (SELECT SUM(NVL(poll.quantity,0) - NVL(poll.quantity_cancelled,0))
					                FROM  po_line_locations_all poll
				                  WHERE  poll.po_line_id = pol.po_line_id
				                     AND  poll.shipment_type IN ('STANDARD', 'BLANKET', 'PLANNED') )
      WHERE pol.po_line_id = j.po_line_id
	  AND NVL(pol.cancel_flag,'N') = 'N'
	  AND NVL(pol.closed_code,'OPEN') != 'FINALLY CLOSED';
	  
	 		  
     UPDATE mtl_supply ms  
	  SET ms.quantity=0,
	      ms.change_flag='Y' 
      WHERE (ms.supply_type_code='PO' AND ms.po_line_id = j.po_line_id
	  AND NVL(ms.change_flag,'Y')='Y');
														
			  	 
	FND_FILE.PUT_LINE(fnd_file.output, 'Canceling PO Shipment details for the po line '||j.po_line_id);
  	           
      UPDATE PO_LINE_LOCATIONS POLL 
	   SET CLOSED_CODE ='CLOSED',
	       CLOSED_DATE =DECODE(POLL.closed_code,'CLOSED',SYSDATE,NULL),
	       CLOSED_REASON =DECODE(POLL.closed_code,'CLOSED','Cancel Testing',NULL),
	       CLOSED_BY = DECODE(POLL.closed_code,'OPEN',NULL,l_userid) 
	 WHERE POLL.po_line_id = j.po_line_id
	   AND POLL.po_release_id IS NULL 
	   AND POLL.closed_date IS NULL 
	   AND NVL(POLL.closed_code, 'OPEN') IN ('CLOSED','OPEN','CLOSED FOR INVOICING','CLOSED FOR RECEIVING');
				
				
	FND_FILE.PUT_LINE(fnd_file.output, 'Canceling Item  details for the po line ');
				
				
         UPDATE PO_LINES_all POL  
	   SET    POL.closed_code= 'CLOSED',
		  POL.last_update_date=SYSDATE ,
		  POL.last_updated_by= l_userid,
		  POL.closed_by=l_userid,
		 POL.closed_date= SYSDATE,
		 POL.closed_reason= 'SO Line is Canceled'
	   WHERE ((POL.po_line_id= j.po_line_id AND NVL(POL.closed_code,'OPEN')<>'CLOSED') 
	   AND   NVL(POL.closed_code,'OPEN')<>'FINALLY CLOSED');
  
  
	  UPDATE mtl_supply ms  
	     SET ms.quantity=0,
		   ms.change_flag='Y' 
	  WHERE (ms.supply_type_code='PO' 
	   AND  ms.po_line_location_id =j.line_location_id);
         
                     
        DELETE FROM mtl_supply ms  
         WHERE ms.supply_type_code='PO' 
           AND ms.po_line_id = j.po_line_id
           AND ms.change_flag='Y' ;
      
	FND_FILE.PUT_LINE(fnd_file.output, 'Deleting the supply if any ');
    
     
       UPDATE PO_HEADERS_ALL POH
    	    SET POH.last_update_date = SYSDATE,
    		  POH.last_updated_by = l_userid,
    		  POH.attribute2 = NULL,
    		  POH.attribute3 = 'Y'
    	  WHERE POH.po_header_id = j.po_header_id;
    		
    		
	 UPDATE  po_line_locations_all
	    SET  attribute3 = 'Y'
	  WHERE  po_line_id = j.po_line_id
	    AND  po_header_id = j.po_header_id
	    AND  attribute2 IS NOT NULL;
	      
         COMMIT;
	
 END LOOP;
       
   --END LOOP;
   
   
    m:=1;

    Fnd_file.put_line(fnd_file.output,'**2--Starting the IR  To ISO  Canellation ');

  FOR k IN c3  LOOP
		
		  fnd_client_info.set_org_context(k.org_id);
				COMMIT;
  
        m:=1;

          l_message:=NULL;
          Fnd_file.put_line(fnd_file.output,'*********************************************************************************************************************************');
          Fnd_file.put_line(fnd_file.output,' ');
          Fnd_file.put_line(fnd_file.output,'----Processing Req #--'||K.requisition_number||'--REQ Ln #--'||k.line_num||'--Req Id- '||k.requisition_header_id||'--Req -Ln Id--'||k.requisition_line_id);
										Fnd_file.put_line(fnd_file.output,'---Cancelling  ISO #-- '||k.order_number2||'--ISO Ln #--'||k.order_line_num||'--Flow Status cose-- '||k.flow_status_code||'--ISO ID--'||k.header_id2||'--ISO Ln Id-- '||k.line_id2||'org id'||k.org_id);
         -- Fnd_file.put_line(fnd_file.output,'---Cancelling the SO line id ---'||k.line_id2);
   
            l_line_tbl(m) := oe_order_pub.g_miss_line_rec;
            l_line_tbl(m).line_id :=  k.line_id2;
            l_line_tbl(m).header_id := k.header_id2;
            l_line_tbl(m).cancelled_flag := 'Y';
            l_line_tbl(m).cancelled_quantity := k.ordered_quantity;
            l_line_tbl(m).change_reason := 'SYSTEM'; --'Automatically Cancelled';--
            l_line_tbl(m).operation := OE_GLOBALS.G_OPR_UPDATE;
            l_line_tbl(m).ordered_quantity := 0;
            l_line_tbl(m).flow_status_code := 'CANCELLED' ;
            
  
          --FND_FILE.PUT_LINE(fnd_file.output,'Cancelling the Sales order Line   Id ----- '||k.line_id2);
          
            p_line_tbl := l_line_tbl;
   
            OE_Order_PUB.Process_Order(
            p_api_version_number                    => 1.0,
            p_init_msg_list                         => FND_API.G_TRUE,
            p_return_values                         => FND_API.G_TRUE,
            p_action_commit                         => FND_API.G_TRUE,
            x_return_status                         => x_return_status,
            x_msg_count                             => x_msg_count,
            x_msg_data                              => x_msg_data,
            --p_header_rec                          => l_header_rec, 
            p_line_tbl                              => p_line_tbl,
            x_header_rec                            => l_header_rec,
            x_header_val_rec                        => x_header_val_rec,
            x_Header_Adj_tbl                        => x_Header_Adj_tbl,
            x_Header_Adj_val_tbl                    => x_Header_Adj_val_tbl,
            x_Header_price_Att_tbl                  => x_Header_price_Att_tbl,
            x_Header_Adj_Att_tbl                    => x_Header_Adj_Att_tbl,
            x_Header_Adj_Assoc_tbl                  => x_Header_Adj_Assoc_tbl,
            x_Header_Scredit_tbl                    => x_Header_Scredit_tbl,
            x_Header_Scredit_val_tbl                => x_Header_Scredit_val_tbl,
            x_line_tbl                              => x_line_tbl,
            x_line_val_tbl                          => x_line_val_tbl,
            x_Line_Adj_tbl                          => x_Line_Adj_tbl,
            x_Line_Adj_val_tbl                      => x_Line_Adj_val_tbl,
            x_Line_price_Att_tbl                    => x_Line_price_Att_tbl,
            x_Line_Adj_Att_tbl                      => x_Line_Adj_Att_tbl,
            x_Line_Adj_Assoc_tbl                    => x_Line_Adj_Assoc_tbl,
            x_Line_Scredit_tbl                      => x_Line_Scredit_tbl,
            x_Line_Scredit_val_tbl                  => x_Line_Scredit_val_tbl,
            x_Lot_Serial_tbl                        => x_Lot_Serial_tbl,
            x_Lot_Serial_val_tbl                    => x_Lot_Serial_val_tbl,
            x_action_request_tbl                    => x_action_request_tbl);
												
        IF    x_return_status = 'S' THEN 
               fnd_file.put_line(fnd_file.output,'*****--The ISO line id  STATUS IS  cancelled --for the line is -'||k.line_id2);
               fnd_file.put_line(fnd_file.output,'--x_return_status---'||x_return_status);
	        l_message:='Status=S. ISO Line is cancelled  For this requisition line ';  
  
        ELSE	
		   fnd_file.put_line(fnd_file.output,'****** The SO line id STATUS IS  not cancelled for the line id ---'||k.line_id2);
               fnd_file.put_line(fnd_file.output,'x_return_status '||x_return_status);
		   fnd_file.put_line(fnd_file.output,'Line Could not be cancelled. line is in the status '||k.flow_status_code);
               fnd_file.put_line(fnd_file.output,'API Error Meassage is '||x_msg_data);
               l_message:='Status=E.ISO Line is not  Cancelled For this Requisition line id.Iso Line Status is-- '||k.flow_status_code||'Oracle API Error msg is--'||x_msg_data ; 
       
								
	       OE_MSG_PUB.GET(p_msg_index => m, p_encoded => 'F', p_data => l_message, p_msg_index_out => l_msg_index_out);
              FND_FILE.PUT_LINE(FND_FILE.OUTPUT, ' 1_message '|| l_message);
	  END IF;
													
            
            
          BEGIN
										
	      fnd_file.put_line(fnd_file.LOG,'updating the po requisition line');

          	UPDATE po_requisition_lines_all
          	   SET attribute12=SUBSTR(l_message,1,150)
          	 WHERE requisition_line_id=k.requisition_line_id;

	     m:=m+1;
	     
	     COMMIT;
	     
	     EXCEPTION 
	      WHEN OTHERS THEN 
	      FND_FILE.PUT_LINE(fnd_file.output,'****************Error is err msg ********'||SQLERRM);
	     
	    END;

       END LOOP;
		
	  Fnd_file.put_line(fnd_file.output,'Ending the Fluke Europe PR/IR To PO/ISO Canellation statement');
        Fnd_file.put_line(fnd_file.output,'************************************************************************************************************');
				
	EXCEPTION 
	  WHEN OTHERS THEN 
	      FND_FILE.PUT_LINE(fnd_file.output,'****************Error in the procedure  is err msg ********'||SQLERRM);
			 
		
END PRIR_TO_POISO_CANCELLATION ;


PROCEDURE MAIN           (p_errbuff OUT VARCHAR2,
                          p_retcode OUT VARCHAR2) IS 
          BEGIN 
          
          fnd_file.put_line(fnd_file.output,'Starting the Fluke Europe PR/IR To SO/PO Cancellation Program');
          Prir_to_poiso_cancellation;
									          
          END;
                                    
END FLK_PRIR_TO_POISO_CANCEL;

/

show err;