---------------------------------------------------------------------------------------------------------------------------------
---
--- Progam Name		: 	FLKMFG OE PR PO CANCELLATION
--- Program File Name	:	OE_PR_PO_CANCELLATION_PKG_B.sql
--- Program Type        : 	Package Body
--- Parameters		: 	N/A
--- DEV Instance		:	DEV9
--- Description         : 	This Package Cancells the IRS ,POS ,ISO for the SO which are cancelled 
---				
-----				
--- Created By                 Prashant Kale 
--- Creation Date             21-Aug-2007
-----
------
--- Modification History:      Date	 	Modified By		Comments
---				       ----		-----------		--------
---					            Prashant Kale    
---------------------------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE PACKAGE BODY FLK_SO_TO_PR_IR_CANCEL
  IS 
   l_userid NUMBER           :=fnd_profile.value('USER_ID'); 
   l_conc_request_id NUMBER  :=fnd_profile.value('CONC_REQUEST_ID');

  PROCEDURE SO_TO_IR_PR_CANCELLATION
               IS                       
 --This curosr will select the sales order  (sales header id) for those 
 --orders which are cancelled 
 --
 --
     CURSOR C1_OE_ORDER_HEADER IS 
   
         SELECT DISTINCT oeh.header_id,
                            oeh.order_number,
                            oeh.org_id,          
                            oel.line_id,
                            oel.line_number,
			    porla.requisition_line_id
 			   ,porha.requisition_header_id
 			   ,porha.segment1 requisition_number
                           ,porla.line_num		
                    FROM   oe_order_lines_all oel
        			  ,oe_order_headers_all oeh
				  ,po_requisition_lines_all porla
				  ,po_requisition_headers_all porha
				             WHERE  oeh.header_id=oel.header_id
																		AND OEH.OPEN_FLAG='Y'
																		AND OEH.ORDERED_DATE BETWEEN SYSDATE-100000 AND SYSDATE+100000
                       AND oeh.org_id IN (SELECT organization_id
                                         FROM hr_operating_units		
                                         WHERE organization_id IN 
                                         (SELECT organization_id 
				                  FROM hr_all_organization_units 
				                  WHERE attribute17 = 'Yes'))										
			     AND oel.cancelled_flag = 'Y'   
								AND OEL.OPEN_FLAG='N'
                       AND oel.flow_status_code = 'CANCELLED'
			     AND OEL.LINE_ID=TO_NUMBER(porla.attribute4)
			     AND porha.requisition_header_id = porla.requisition_header_id
			    -- AND porda.requisition_line_id  = porla.requisition_line_id
		           AND PORLA.cancel_flag!='Y'																									
													UNION             
          SELECT DISTINCT oeh.header_id,
                 oeh.order_number,
                 oeh.org_id,          
                 oel.line_id,
                 oel.line_number,
		     porla.requisition_line_id,
 		     porha.requisition_header_id,
 		     porha.segment1 requisition_number,
                 porla.line_num		
            FROM oe_order_lines_all oel,
        	     oe_order_headers_all oeh,
		     po_requisition_lines_all porla,
		     po_requisition_headers_all porha																								
           WHERE 1=1
             AND porha.org_id IN (SELECT organization_id
             	                  FROM hr_operating_units		
                                   WHERE organization_id IN 
                                         (SELECT organization_id 
				                    FROM hr_all_organization_units 
				                    WHERE attribute17 = 'Yes'))
	       AND porha.segment1 = oeh.orig_sys_document_ref								
																		 AND porha.requisition_header_id=porla.requisition_header_id															 
																			AND porla.requisition_header_id = oel.source_document_id
      	 AND porla.requisition_line_id  = oel.source_document_line_id
		 AND oel.cancelled_flag = 'Y'  
			             AND oel.flow_status_code = 'CANCELLED'
		 AND oel.header_id = oeh.header_id
		 AND NVL(PORLA.cancel_flag,'N') = 'N';																																																										
 BEGIN 
           fnd_file.put_line(fnd_file.output,'Strating the Fluke Europe SO/ISO To IR/PR Cancellation Program');
           fnd_file.put_line(fnd_file.output,'************************DATE--'||SYSDATE);
	   fnd_file.put_line(fnd_file.output,'*****USER id '||l_userid||'****************REQUEST ID --'||l_conc_request_id);
	   fnd_file.put_line(fnd_file.output,'********Processing the Sales order lines  to  cancel the requsitions');
			
               ---OPEING THE CURSOR TO FETCH THE DATA  SO LINES WHICH ARE CANCELLED 
			 
                  FOR I IN C1_OE_ORDER_HEADER LOOP                      --C1_OE_ORDER_HEADER loop  STARTED  
			    fnd_file.put_line(fnd_file.output,'*************************************************************************************************************************************************************');			   
			    fnd_file.put_line(fnd_file.output,'-----Processing the SO #---'||i.order_number||'--SO Ln # '||i.line_number||'---SO Id-- '||i.header_id||'--SO Ln Id'||i.line_id);			   
			    fnd_file.put_line(fnd_file.output,'-----Cancelling the Req #No--'||I.requisition_number||'--Req Ln# --'||i.line_num||'--Req Id ---'||I.requisition_header_id||'--Req Ln Id- '||I.requisition_line_id);

			                   
                     BEGIN                                                                                                                --UPDATE PO_REQUISITION_LINES Start;
				UPDATE PO_REQUISITION_LINES_all PORL  
				 SET PORL.cancel_flag='Y',
		    		     PORL.cancel_date = SYSDATE,
		    		     PORL.cancel_reason = 'Custom B2B Cancellation',
	  	    		     PORL.LAST_UPDATE_DATE = SYSDATE ,
		    		     PORL.LAST_UPDATED_BY=l_userid 
  		     	    	 WHERE PORL.requisition_line_id = I.requisition_line_id;
																COMMIT; ---The requstion id which need select * from to cancel
                        EXCEPTION
				 WHEN OTHERS THEN 
				   fnd_file.put_line(fnd_file.LOG,'Error while updating the requstion id--'||I.requisition_line_id);
				   fnd_file.put_line(fnd_file.LOG,'Error is '||SQLERRM);
			   END; 
                                                                                                                --UPDATE PO_REQUISITION_LINES end;
			END LOOP;   
			
			fnd_file.put_line(fnd_file.output,'Ending the Fluke Europe SO/ISO To IR/PR Cancellation Program');                                                                                                            --C1_OE_ORDER_HEADER loop ended
			                                            
         END SO_TO_IR_PR_CANCELLATION;
                                    
                                    
      PROCEDURE MAIN (p_errbuff OUT VARCHAR2,
                      p_retcode OUT VARCHAR2)
                       IS 
                    BEGIN     
                      SO_TO_IR_PR_CANCELLATION; 
                      COMMIT;          
                    END Main;
                             
 END FLK_SO_TO_PR_IR_CANCEL;

/